﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.events.MouseEvent;
	import flash.filters.DropShadowFilter;

	public class Sinuser extends Sprite
	{
		private var bmp:BitmapData;
		private var angle:uint = 0;
		private var support:Sprite = new Sprite();
		private var filterObj:BlurFilter = new BlurFilter(4,4,1);
		private var colors:Array = [0xFFFA02,0xff0000,0xFF4D15];
		private var plusMinus = true;
		private var point:Sprite
		public function Sinuser()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			bmp = new BitmapData(stage.stageWidth,stage.stageHeight,false,0xffffff);
			addChild(new Bitmap(bmp));
			addEventListener(Event.ENTER_FRAME,enterHandler);
			addEventListener(MouseEvent.MOUSE_DOWN, changeHandler);
		}
		private function buildCycle(target:Sprite,angle:uint):Sprite
		{	
			point = new Sprite();
			point.graphics.lineStyle(1,colors[angle%3],1);
			//point.graphics.lineStyle(1, 0x000000);
			//point.graphics.drawCircle(0,0,Math.floor(Math.random()*50));
			point.graphics.drawRect(0, 0, 50, 50);
			target.addChild(point);
			point.x = Math.sin(angle*Math.PI/180)*10;
			point.y = Math.cos(angle*Math.PI/180)*10;
			return point;
		}
		private function changeHandler(e:MouseEvent):void{
			colors = [Math.random()*0xffffff, Math.random()*0xffffff, Math.random()*0xffffff]
		}
		private function enterHandler(e:Event):void
		{	
			var basis:Sprite = new Sprite();
			basis.x = stage.stageWidth/2;
			basis.y = stage.stageHeight/2;
			support.addChild(basis);
			for(var i:uint=0;i<25;i++){
				basis = buildCycle(basis,angle*i);
			}
			var m:Matrix = new Matrix();
			m.rotate(angle/100);
			m.translate(stage.stageWidth*2,stage.stageHeight*2);
			m.scale(0.25,0.25);
			if(angle%100 == 0){
				bmp.applyFilter(bmp,bmp.rect,new Point(0,0),filterObj);
			}
			bmp.draw(support,m);
			support.removeChildAt(0);
			angle++;
		}
	}
}